; Script generated by the HM NIS Edit Script Wizard.

; HM NIS Edit Wizard helper defines
!define PRODUCT_NAME "Power Supplies"
!define PRODUCT_VERSION "0.4.1"
!define PRODUCT_PUBLISHER "Pozsar Zsolt"
!define PRODUCT_WEB_SITE "http:\\www.pozsarzs.hu"
!define PRODUCT_DIR_REGKEY "Software\Microsoft\Windows\CurrentVersion\App Paths\powersupplies.exe"
!define PRODUCT_UNINST_KEY "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PRODUCT_NAME}"
!define PRODUCT_UNINST_ROOT_KEY "HKLM"

; MUI 1.67 compatible ------
!include "MUI.nsh"

; MUI Settings
!define MUI_ABORTWARNING
!define MUI_ICON "${NSISDIR}\Contrib\Graphics\Icons\modern-install.ico"
!define MUI_UNICON "${NSISDIR}\Contrib\Graphics\Icons\modern-uninstall.ico"

; Language Selection Dialog Settings
!define MUI_LANGDLL_REGISTRY_ROOT "${PRODUCT_UNINST_ROOT_KEY}"
!define MUI_LANGDLL_REGISTRY_KEY "${PRODUCT_UNINST_KEY}"
!define MUI_LANGDLL_REGISTRY_VALUENAME "NSIS:Language"

; Uninstaller pages
!insertmacro MUI_PAGE_WELCOME
!insertmacro MUI_PAGE_LICENSE "$(MUILicense)" 
!insertmacro MUI_PAGE_COMPONENTS
!insertmacro MUI_PAGE_DIRECTORY
!insertmacro MUI_PAGE_INSTFILES
!define MUI_FINISHPAGE_RUN "$INSTDIR\powersupplies.exe"
!define MUI_FINISHPAGE_SHOWREADME "$INSTDIR\documents\readme.txt"
!insertmacro MUI_PAGE_FINISH

; Uninstaller pages
!insertmacro MUI_UNPAGE_WELCOME
!insertmacro MUI_UNPAGE_CONFIRM
!insertmacro MUI_UNPAGE_INSTFILES
!insertmacro MUI_UNPAGE_FINISH

; Language files
!insertmacro MUI_LANGUAGE "English"
!insertmacro MUI_LANGUAGE "Hungarian"

; License Language
LicenseLangString MUILicense ${LANG_ENGLISH} "powersupplies\documents\copying.txt"
LicenseLangString MUILicense ${LANG_HUNGARIAN} "powersupplies\documents\copying.txt"

; MUI end ------

Name "${PRODUCT_NAME} ${PRODUCT_VERSION}"
OutFile "powersupplies-0.4.1-win32.exe"
InstallDir "$PROGRAMFILES\Power Supplies"
InstallDirRegKey HKLM "${PRODUCT_DIR_REGKEY}" ""
ShowInstDetails show
ShowUnInstDetails show

Function .onInit
  !insertmacro MUI_LANGDLL_DISPLAY
FunctionEnd

Section "Main files" SEC01
  SetOutPath "$INSTDIR\documents"
  SetOverwrite try
  File "powersupplies\documents\authors.txt"
  File "powersupplies\documents\changelog.txt"
  File "powersupplies\documents\copying.txt"
  File "powersupplies\documents\install.txt"
  File "powersupplies\documents\readme.txt"
  File "powersupplies\documents\version.txt"
  SetOutPath "$INSTDIR\documents\hu"
  File "powersupplies\documents\hu\copying.txt"
  File "powersupplies\documents\hu\install.txt"
  File "powersupplies\documents\hu\readme.txt"
  SetOutPath "$INSTDIR\figures"
  File "powersupplies\figures\module_01.png"
  File "powersupplies\figures\module_02.png"
  File "powersupplies\figures\module_03.png"
  File "powersupplies\figures\module_04.png"
  File "powersupplies\figures\module_05.png"
  File "powersupplies\figures\module_06.png"
  File "powersupplies\figures\module_07.png"
  File "powersupplies\figures\module_08.png"
  File "powersupplies\figures\module_09.png"
  File "powersupplies\figures\module_10.png"
  File "powersupplies\figures\module_11.png"
  SetOutPath "$INSTDIR\help"
  File "powersupplies\help\styles.css"
  File "powersupplies\help\en.html"
  File "powersupplies\help\en_cmdparams.html"
  File "powersupplies\help\en_hotkeys.html"
  File "powersupplies\help\en_intro.html"
  File "powersupplies\help\hu.html"
  File "powersupplies\help\hu_cmdparams.html"
  File "powersupplies\help\hu_hotkeys.html"
  File "powersupplies\help\hu_intro.html"
  SetOutPath "$INSTDIR"
  File "powersupplies\powersupplies.exe"
  File "powersupplies\readme.txt"
  CreateShortCut "$DESKTOP\Power Supplies.lnk" "$INSTDIR\powersupplies.exe"
  CreateDirectory "$SMPROGRAMS\Power Supplies"
  CreateShortCut "$SMPROGRAMS\Power Supplies\Power Supplies.lnk" "$INSTDIR\powersupplies.exe"
SectionEnd

Section "Translate HU" SEC02
  SetOutPath "$INSTDIR\languages\hu"
  File "powersupplies\languages\hu\powersupplies.mo"
  File "powersupplies\languages\hu\powersupplies.po"
  SetOutPath "$INSTDIR\languages"
  File "powersupplies\languages\powersupplies.pot"
SectionEnd

Section -AdditionalIcons
  SetOutPath $INSTDIR
  CreateDirectory "$SMPROGRAMS\Power Supplies"
  CreateShortCut "$SMPROGRAMS\Power Supplies\Uninstall.lnk" "$INSTDIR\uninst.exe"
SectionEnd

Section -Post
  WriteUninstaller "$INSTDIR\uninst.exe"
  WriteRegStr HKLM "${PRODUCT_DIR_REGKEY}" "" "$INSTDIR\powersupplies.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayName" "$(^Name)"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "UninstallString" "$INSTDIR\uninst.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayIcon" "$INSTDIR\powersupplies.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayVersion" "${PRODUCT_VERSION}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "URLInfoAbout" "${PRODUCT_WEB_SITE}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "Publisher" "${PRODUCT_PUBLISHER}"
SectionEnd

; Section descriptions
  LangString DESC_Section1 ${LANG_ENGLISH} "Required files"
  LangString DESC_Section2 ${LANG_ENGLISH} "Hungarian translate"
  LangString DESC_Section1 ${LANG_HUNGARIAN} "Ktelez llomnyok"
  LangString DESC_Section2 ${LANG_HUNGARIAN} "Magyar fordts"
  !insertmacro MUI_FUNCTION_DESCRIPTION_BEGIN
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC01} $(DESC_Section1)
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC02} $(DESC_Section2)
  !insertmacro MUI_FUNCTION_DESCRIPTION_END

; Section uninstall
  Function un.onInit
  !insertmacro MUI_UNGETLANGUAGE
  FunctionEnd

Section Uninstall
  Delete "$INSTDIR\uninst.exe"
  Delete "$INSTDIR\readme.txt"
  Delete "$INSTDIR\powersupplies.exe"
  Delete "$INSTDIR\help\styles.css"
  Delete "$INSTDIR\help\en.html"
  Delete "$INSTDIR\help\en_cmdparams.html"
  Delete "$INSTDIR\help\en_hotkeys.html"
  Delete "$INSTDIR\help\en_intro.html"
  Delete "$INSTDIR\help\hu.html"
  Delete "$INSTDIR\help\hu_cmdparams.html"
  Delete "$INSTDIR\help\hu_hotkeys.html"
  Delete "$INSTDIR\help\hu_intro.html"
  Delete "$INSTDIR\figures\module_01.png"
  Delete "$INSTDIR\figures\module_02.png"
  Delete "$INSTDIR\figures\module_03.png"
  Delete "$INSTDIR\figures\module_04.png"
  Delete "$INSTDIR\figures\module_05.png"
  Delete "$INSTDIR\figures\module_06.png"
  Delete "$INSTDIR\figures\module_07.png"
  Delete "$INSTDIR\figures\module_08.png"
  Delete "$INSTDIR\figures\module_09.png"
  Delete "$INSTDIR\figures\module_10.png"
  Delete "$INSTDIR\figures\module_11.png"
  Delete "$INSTDIR\languages\powersupplies.pot"
  Delete "$INSTDIR\languages\hu\powersupplies.po"
  Delete "$INSTDIR\languages\hu\powersupplies.mo"
  Delete "$INSTDIR\documents\authors.txt"
  Delete "$INSTDIR\documents\changelog.txt"
  Delete "$INSTDIR\documents\copying.txt"
  Delete "$INSTDIR\documents\install.txt"
  Delete "$INSTDIR\documents\readme.txt"
  Delete "$INSTDIR\documents\version.txt"
  Delete "$INSTDIR\documents\hu\install.txt"
  Delete "$INSTDIR\documents\hu\readme.txt"
  Delete "$INSTDIR\documents\hu\copying.txt"

  Delete "$SMPROGRAMS\Power Supplies\Uninstall.lnk"
  Delete "$DESKTOP\Power Supplies.lnk"
  Delete "$SMPROGRAMS\Power Supplies\Power Supplies.lnk"

  RMDir "$SMPROGRAMS\Power Supplies"
  RMDir "$INSTDIR\help"
  RMDir "$INSTDIR\figures"
  RMDir "$INSTDIR\languages\hu"
  RMDir "$INSTDIR\languages"
  RMDir "$INSTDIR\documents\hu"
  RMDir "$INSTDIR\documents"
  RMDir "$INSTDIR"

  DeleteRegKey ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}"
  DeleteRegKey HKLM "${PRODUCT_DIR_REGKEY}"
  SetAutoClose true
SectionEnd
